# ROADMAP [中文版](./zh/ROADMAP.md)

The ROADMAP is a list of product development plans that the core development team anticipates of Choerodon. It details the future's direction of Choerodon, but may change over time. We hope that you can learn about our plans and Vision through ROADMAP, if you have any better ideas, welcome to [ISSUE](https://github.com/choerodon/choerodon/issues).

## Platform foundation

- [x] Platform overview
- [x] Organization overview
- [x] Role management
- [x] Transaction management
    - [x] Transaction definition
    - [x]  Transaction instance
- [x] Root user
- [x] User management
- [x] Menu management
- [x] Task management
- [x] System announcement
- [x] Webhook log
- [x] Mail log
- [x] General management
- [ ] Page customization
- [x] Authorization management
- [x] Message service
    - [x] Notification configuration
    - [x] Receive configuration
- [x] Microservice instance
- [x] Interface
    - [x] Interface statistics
    - [x] Menu statistics
- [x] Choerodon CLI tools
- [x] Project type split
- [ ] Personal workbench
- [x] Platform user audit function
- [x] The installation tool supports commercial installation
- [ ] Project Overview
- [ ] Platform data recovery function
- [ ] System multi component transaction optimization
## Agile collaboration

- [x] Iteration plan
    - [x] Kanban management
      - [x] Configure columns and states
      - [x] Choose a lane
      - [x] Multi board
      - [x] Define work calendar
    - [x] Iteration workbench
    - [x] End sprint
- [x] Team member management
- [x] Module management
- [x] Work list
    - [x] Question type
      - [x] epic
      - [x] User stories
      - [x] task
      - [x] defect
    - [x] Planning sprint
    - [x] To Do List
    - [x] version management
- [x] Story map
- [ ] State machine
## Knowledge base

- [x] Knowledge base management
    - [x] Organization knowledge base
    - [x] Project knowledge base
- [x] Document management
- [x] Documents sharing
## Code development

- [x] Application service management
    - [x] Shared application services
    - [x] Authority management
- [x] Code management
    - [x] Code warehouse
    - [x] Branch Management
    - [x] Merge request
    - [x] Continuous integration
    - [x] sign
    - [x] Code quality
- [x] CI pipeline
    - [x] Global variable configuration
    - [x] Visualization process
    - [x] Integrate nexus product library
    - [x] Integrated sonar code checking
    - [x] Support go language process
    - [x] File cache
## Test management

- [x] Use case library
    - [x] Case folder
    - [x] test case
- [x] test plan
    - [x] Schedule folder
    - [x] Test execution
- [x] automated testing
    - [ ] API testing
    - [ ] unit testing
    - [ ] Stress testing
    - [ ] Automated UI testing
## Continuous deployment

- [x] Application deployment
- [x] resources
    - [x] Instance view
    - [x] Resource view
- [ ] Assembly line CD
    - [ ] Integration of CD pipeline and CI process
    - [ ] CD supports host image deployment
    - [ ] CD supports the host to deploy the product library
    - [ ] CD supports application cluster deployment
- [x] Environment configuration
- [x] Cluster management
    - [x] Node management
    - [x] Environmental management
    - [x] Authority management
    - [ ] Network management
    - [ ] Docking and fusion monitoring platform
- [ ] Support the deployment of product library and product host
- [ ] Harbor chart integration
- [ ] Security scanning function of container image
- [ ] Apply custom health checks
## operation management

- [x] Chart
    - [x] Agile Report
      - [x] Burn-down chart
      - [x] Sprint Report
      - [x] Cumulative flow chart
      - [x] Version Report
      - [x] Iterative velocity chart
      - [x] Epic Report
      - [x] Statistical chart
      - [x] Epic burnup chart
      - [x] Version burnup chart
- [x] Test report
    - [x] Test summary
    - [x] Test traceability Report
- [x] Devops Report
    - [x] Code submission diagram
    - [x] Construction duration chart
    - [x] Construction times graph
    - [x] Deployment time chart
    - [x] Deployment times chart
- [x] transaction management