# Changelog

本文档记录了Choerodon 0.10.0 中 **微服务开发框架、持续交付、敏捷管理、知识管理、测试管理**等功能的优化和bug修复记录。

## 知识管理

### [0.10.0] - 2018-10-15

### 新增

- 新增在编辑器中添加敏捷issue的宏
- 新增了wiki系统中产品需求的模板
- 新增了wiki系统的最近空间功能
- 新增了同步失败的组织或项目可以手动重试的功能
- 新增创建失败的空间可以手动重试功能

### 修改

- 修改了wiki系统树状浏览器样式
- 修改了wiki系统编辑器的布局
- 修改了wiki系统部署中初始化配置的模式
- 修改了wiki系统页面导出的布局
- 修改了wiki系统的子预览页布局
- 修改了查看源码页面布局
- 修改了复制页面的布局
- 修改了重命名页的布局
- 修改了删除页面的布局
- 修改了邮件分享页的布局
- 修改了知识管理服务支持Oracle数据库

### 修复

- 修复了Wiki系统的登录授权时长与Choerodon不一致的问题
- 修复了wiki系统中部分页面中英文混杂的问题
- 修复wiki管理界面删除空间之后，没办法创建同名空间的问题
- 修复空间主页最近活动图标显示错误的问题
- 修复空间首页描述内容错误的问题
- 修复Wiki系统头部导航栏显示错位的问题

## 敏捷管理

### [0.10.0] - 2018-10-15

### 新增

- 新增史诗燃耗图功能：用户可以在报表界面中选择史诗燃耗图，图表和报告展示了团队在不同史诗中取得的工作进展，并预估未来冲刺完成趋势
- 新增版本燃耗图功能：用户可以在报表界面中选择版本燃耗图，图表和报告展示了团队在不同版本中取得的工作进展，并预估未来冲刺完成趋势
- 新增迭代工作台功能：用户可以在冲刺工作台中查看问题的状态、优先级、经办人、类型分布，冲刺的简要信息、燃尽图、问题列表详情
- 新增报告工作台功能：用户可以在报告工作台中查看累积流图、经办人分布图等图表的实时数据
- 新增故事地图导出图片功能
- 新增故事地图全屏操作功能

### 修改

- 优化了故事地图滑动功能的流畅性
- 故事地图在移动问题时可以记录其位置
- 故事地图在需求池拖动问题的时候可以记录其位置
- 优化了部分页面内存
- 报告中的燃尽图、冲刺报告可以建立缓存保留上一次选择的冲刺及其单位
- 修改看板配置中添加状态的样式
- 优化了累积流量图获取时间函数
- 仪表盘中的版本进度过滤掉归档版本
- 设置中创建问题链接增加了重名校验
- 故事地图各种泳道支持上下拖动排序

### 修复

- 修复活跃冲刺中拖动到有多种状态的一列处，出现的页面堆叠现象
- 修复活跃冲刺界面拖动问题排序，页面数据会延迟的问题
- 修复待办事项创建问题执行时间过长问题
- 修复问题管理导出Excel中问题的描述带有格式的问题
- 修复冲刺燃尽图根据问题数量统计在一部分条件下加载失败的问题

### 删除

- 分页功能，若低于10条则不显示分页工具栏

## 持续交付

### [0.10.0] - 2018-10-15

### 新增

- 新增环境分组，支持按照环境分组查看流水线
- 新增域名证书管理功能，支持域名证书的申请与上传
- 新增DevOps报表功能，支持查看代码提交、应用构建以及应用部署的情况
- 新增部署总览功能，以便查看所有应用在各个环境下的部署情况，并能在此页面完成应用最新版本的快速部署
- 支持使用shell命令操作pod以便于调试
- 支持创建标记时填写release notes，并支持查看编辑与修改
- 新增查看容器日志时的Stop Following、Go Top功能，并支持全屏查看容器日志
- 新增容器界面选择环境与应用的下拉框和应用版本界面选择应用的下拉框便于搜索与过滤

### 修改

- 优化了容器日志长链接的状态
- 统一了系统内状态显示的图标
- 网络、域名、实例、应用部署等相关状态优化
- 优化了总览界面的加载速度
- 优化了表格的分页、筛选、排序和刷新

### 修复

- 修复部署超时失败后无法操作的问题
- 修复部署部分替换实例未做修改判断的问题
- 修复0.9.0版本网络列表提示错误、时间组件显示错误的问题
- 修复网络编辑中实例状态报错的问题
- 修复创建应用时,删掉应用模板里面的commit的问题
- 修复创建同名项目时，gitlab组创建失败的问题
- 修复页面连接文档的icon不统一的问题
- 修复gitops解释逻辑，list存放重复旧文件对象关系导致删除重复数据报错的问题
- 修复网络创建中添加端口按钮消失的问题

### 删除

- 移除部署流水线实例管理中的多应用视图

## 测试管理

### [0.10.0] - 2018-10-15

### 新增

- 增加了Oracle数据库支持
- 增加了测试计划功能
- 测试用例管理添加文件夹层级
- 用例管理侧边栏具有宽窄两种展示
- 新增测试计划页面
- 测试执行增加用户筛选

### 修改

- 测试循环和测试阶段的开始和结束时间成为必选项
- 测试循环下将不再直接含有测试执行
- 测试计划页面执行的跳转只能查看执行信息，不能进行编辑
- 用例创建时，版本成为必选项，文件夹成为可选项
- 原测试循环界面更改为测试执行界面
- 报表去除选取用例的功能
- 修改报表数据源选择操作，当前只显示拥有测试关联的数据
- 报表的执行跳转，无法对执行进行编辑

### 修复

- 修复table内编辑的保存操作
- 修复一些样式问题
- 修复拖动table没有搜索到数据的样式问题

## Choerodon微服务开发框架

### [0.10.0] - 2018-10-15

### 新增

**0.10.0显著新增特性**

- 新增发送设置，平台管理员和组织管理员可以设置发送的模板样式及规则
- 新增站内信模板，平台管理员可定义发送给用户的站内信内容
- 新增消息记录，平台管理员和组织管理员可以查看邮件发送的记录
- 新增任务明细，开发者可以创建和管理定时任务，包括简单任务和cron任务
- 新增执行记录，开发者可以查看定时任务的执行记录
- 新增可执行程序，开发者可以查看定时任务可调用的程序（类）
- 新增消息通知，用户可以接收到站内信的消息通知
- 新增角色分配批量导入，平台管理员、组织管理员和项目管理员可以下载导入模板，填写后上传文件批量导入用户角色信息
- 新增找回密码，登录界面支持忘记密码时进行邮箱验证重置密码

**控件0.4.0**

- 增加新的图标
- List添加empty属性
- Table添加empty属性
- Card添加onHeadClick属性
- Input添加showPasswordEye属性用来控制显示密码的控件

**boot0.8.0**

- 增加可定制化仪表盘功能
- 添加初始化脚本Oracle 支持

**框架的依赖0.6.4**

- 默认角色添加平台开发者
- 定时任务通用注解
- swagger 的permission 添加了是否是内部接口的字段
- 通用mapper支持oracle数据库
- choerodon-starter-swagger中邮件模版扫描添加了从classPath加载文件的功能

### 修改

**0.10.0显著修改特性**

- 仪表盘配置优化为可在界面上控制哪些角色可见
- 邮件模板创建时优化为可添加网络图片，并且支持HTML编码
- API 测试修改为内部接口不能在页面进行测试
- 修改密码优化为LADP用户不能修改密码

**控件0.4.0**

- IconSelect搜索修改为不区分大小写
- 修改table样式
- input框修改为禁用时hover上去显示默认禁用图标

**boot0.8.0**

- 升级组件库choerodon-ui@0.3.9
- 优化choerodon-front-boot的开发模式

### 修复

**0.10.0显著修复特性**

- 修复API测试加载缓慢的问题
- 修复新导入的ldap用户报错的问题
- 修复密码策略校验的问题
- 修复平台角色分配过滤的问题

**控件0.4.0**

- 修复级联选择器样式问题
- 修复可编辑单元格示例无法编辑单元格的bug
- 修复Select使用方向键选择时样式缺失的bug
- 修复input有字数限制且在formitem中存在验证时formitem之间上下间距不对的问题
- 修复Sidebar没有getContainer属性的bug
- 修复 Input和select在compact模式和正常模式下不能对齐的问题
- 修复加载图标未置于顶层的问题
- 表单输入框带有字数限制时，优化为报错提示时报错信息与横线无间距，且隐藏字数限制提示

**boot0.8.0**
- 修复IE兼容性问题