# Changelog

本文档记录了Choerodon 0.13.0 中 **知识管理、敏捷管理、微服务开发框架、持续交付、测试管理**等功能的优化和BUG修复记录。

## 知识管理

### 新增

- 新增wiki用户个人空间，在此可创建属于自己的页面。
- 新增wiki界面部分英文汉化。
- 新增wiki分类收藏，页面可以选择收藏在不同的文件夹。
- 新增修改猪齿鱼组织、项目名称并同步到wiki的功能。
- 新增删除wiki组中有重复用户的功能。
- 新增wiki编辑器的格式刷和对齐方式。
- 新增wiki文章选中部分能加入注释的功能。

### 修改

- 修改wiki左侧边栏菜单显示。
- 修改wiki右上角通知样式。
- 修改wiki右上角用户信息下拉框样式。
- 修改wiki文章样式，显示标准A4纸大小。
- 修改wiki页面中文翻译错误。
- 修改wiki菜单数据过多，增加按钮显示全部。
- 修改wiki更多下拉框样式。

### 修复

- 修复safari浏览器编辑页面文章无法滚动。
- 修复wiki编辑页面图片样式变形。
- 修复修改组织、项目名称，wiki空间名与标题不统一。
- 修复旧数据wiki组中用户有"."符号的用户权限不生效的问题

### 删除

- 删除wiki界面打印预览、查看源码、重命名等不常用功能。

## 敏捷管理

### 新增

- 统计图增加标签维度，同时增加冲刺、版本、时间过滤条件。
- 面板设置中新增修改面板名称功能，同时增加重名校验。
- 问题详情窄样式增加日志信息。
- 问题在创建的时候支持填入工时、故事点。
- 增加史诗、模块、版本重名校验。

### 修改

- 待办事项中选中问题用户动作监听优化。
- 部分页面样式优化。
- 优化燃尽图计算逻辑。

### 修复

- 待办事项中计划中冲刺人员信息统计重复。
- 累积流图脏数据修复(需要手动调用进行修复)。
- 创建状态、删除状态导致状态机草稿配置表产生脏数据后发布不可用。
- 日期选择器的节假日显示错误。
- 状态机方案搜索异常。
- 状态机方案发布后，被移除的状态机仍然为活跃状态。
- 敏捷服务增加状态，从状态机节点的发布配置和草稿配置中同时添加，并修复脏数据。
- 敏捷服务删除状态，从状态机节点的发布配置和草稿配置中同时移除，并修复脏数据。

## 持续交付

### 新增

- 开发控制台界面新增流水线模块，其中包括：分支管理、持续集成与应用版本；支持以分支为中心在流水线中进行开发操作
- 网络模块中目标对象部分新增支持Endpoints类型的网络设置
- 网络模块中网络配置部分新增支持LoadBalancer的选项
- 实例详情模块新增StatefulSet、DaemonSet、PVC、Service以及Ingress的详情展示
- 实例详情内新增Pod的增减功能，支持在当前界面直接增减Pod的数量
- 应用管理模块新增导入应用的功能，支持从Github和GitLab库中导入已有应用，并按照所选应用模板为导入的应用添加相应的文件
- 预定义模板新增SpringBoot、Go应用模板
- 容器界面新增显示每个Pod中各个Container的名称与状态

### 修改

- 创建网络时，网络配置部分选择NodePort时，节点端口改为了非必填
- 容器界面详细区分了Pod与容器（container）的概念，使界面更加直观明了
- 优化了实例详情界面，将实例事件与运行详情模块的顺序进行了调换
- 优化统一了实例事件界面Job与Pod状态的展现方式
- 优化了上传证书的过程，调换了Cert文件与Key文件的填写顺序

### 修复

- 修复了实例界面部署实例时，选择应用模块后，无法看到正在部署的实例的问题
- 修复了创建环境时名称校验的问题
- 修复了编辑网络时，目标对象中实例的显示问题
- 修复了创建网络时，由于存在名称相同的文件而引起的报错问题
- 修复了创建域名时，重新选择网络时，对应端口不变的问题
- 修复了通过实例界面点击查看容器详情进行跳转后某些对应应用未显示的问题
- 修复了自动化测试模块里，部署失败后日志丢失的问题
- 修复了创建实例时，实例名为空时未提示的问题
- 修复了实例事件由于操作人员为空导致npe异常的问题
- 修复了环境流水线修改环境分组报错的问题
- 修复处理了webhook时区的问题
- 修复了导出应用自定义名称中带点时引起的格式问题
- 修复了在创建或修改操作提交后，表单内容仍可编辑的问题

### 移除

- 移除了环境总览界面实例详情里的Networking的显示

## 测试管理

### 修改

- 优化测试执行中缺陷关联操作。
- 自动化测试导入测试结果时测试循环时间范围自动调整。
- 测试计划中修改测试阶段时间时自动适配父级测试循环时间。
- 优化测试计划日历组件。

### 修复

- 修复自动化测试运行报错时不会将状态更新成失败的问题。
- 修复测试用例导出时，如果版本中包含空格会导出失败的问题。
- 修复自动化测试生成的测试循环无法删除的问题。
- 修复测试用例、文件夹删除权限错误匹配。

## 微服务开发框架

### 新增

0.13.0显著新增特性

- 仪表盘支持改变大小
- 添加平台统计功能，方便平台管理员了解平台的使用情况
- 主页添加在线人数、新增人数、组织统计、事务失败情况卡片，使平台管理员更便捷的管理平台
- 项目信息和组织信息合并为权限信息
- 组织和项目支持上传头像，更好的标识您的组织或项目
- 消息通知添加系统公告详情页
- 事务实例添加强制将任务置为失败。
- 任务调度添加执行策略
- LDAP添加自定义筛选用户条件，可根据筛选条件在同步用户时过滤 特定用户
- 系统公告添加公告标题以及配置是否发送站内信项

控件0.5.0

- `Icon`: 增加新的图标

boot0.10.0

- 增加记录上次访问url的功能
- 增加菜单点击统计
- 增加boot读取本地config.default.js功能，本地开发复制config.js并命名为config.default.js来编写choerodon-front-boot个人本地开发的配置。

框架的依赖0.9.0

- 分页查询page为负数，不分页查询，将全部的查询结果放到一个page对象里
- asgard中添加新的使用TransactionalProducer创建saga的方式
- asgard中saga和schedule的消费端可以追踪CustomUserDetails
- asgard中saga和schedule线程池添加了maxSize配置，用于配置线程池最大数量

### 修改

0.13.0显著修改特性

- 优化API测试为当在左侧树形结构中，鼠标悬停在路径上时，显示路径描述
- 优化API测试为鼠标悬停在路径框上时，显示完整路径
- 优化菜单配置切换层级时保存的问题

控件0.5.0

- 更改图标字体文件的来源，更改为从npm库中获取
- 优化了图标选择器，图标更大，且只保留常用图标
- 优化table翻页时自动回到第一条元素

boot0.10.0

- dashboard重构，可以在自定义中变更dashboard中卡片大小随意拖动卡片位置
- 阻止了Action下拉菜单组织事件冒泡
- 优化了webpack，从webpack2升级至3，缩减了打包后的dist大小

框架依赖0.9.0

- groovy初始化建表按groovy的名称顺序建表

### 修复

- 修复消息通知日期显示可能覆盖图标的问题。
- 修复富文本编辑器处理后的内容，可能显示边距有误的问题。
- 修复系统公告图片显示可能超出边界的问题。

框架的依赖0.9.0

- 修复excel初始化数据时，如果唯一标识可以为空，会插入重复数据的问题