# Changelog

本文档记录了Choerodon 0.14.0 中 **知识管理、敏捷管理、微服务开发框架、持续交付、测试管理**等功能的优化和BUG修复记录。

## 知识管理

### [0.14.0] - 2019-03-01

### 新增

- 新增了浏览界面上添加注释的功能，且针对弹出的注释进行删除或修改。
- 新增了查看页面支持回到顶部。

### 修改

- 匿名分享取消了全局搜索、空间格式、验证码。
- 修改了在`所有更新`等页面下创建页面的路径，默认选择路径改为在`我的空间`。
- 优化了对用户可见注释的设置记忆，下次无需重复设置。
- 优化了最新和所有更新页面的icon。
- 优化了页面标题的字数限制。
- 优化了全局语言显示。
- 调整文章顶部显示，由文章名更换为上级组织或项目名称。

### 修复

- 修复了侧边栏加载时间长、容易报错的问题。
- 修复了空间移动、复制在空间弹出框的层级显示问题。
- 修复了创建、编辑收藏夹字数显示仅10字的问题。

## 敏捷管理

### [0.14.0] - 2019-03-01

### 新增

- 新增了看板中卡片停留时间预警提示。
- 新增了待办事项中对已完成的issue以编号中线划掉的形式进行显示。
- 新增 了故事点、任务时间支持0.5小数点。
- 新增了冲刺名称重复提示。
- 新增了看板配置的权限限制（项目管理员：配置看板；项目成员：查看配置数据）。
- 新增了创建问题时，支持关联关系。
- 新增了设置中问题链接和快速搜索的筛选过滤器。
- 新增了问题链接的名称重复校验。
- 新增了富文本框字体颜色选择。
- 看板中史诗泳道下新增子任务的显示，便于展示史诗、故事与子任务的层级关系。

### 修改

- 细化了活动日志的描述。
- 优化了看板中的故事泳道下的任务排序，已完成任务会自动移动到看板底部。
- 优化了问题管理、版本详情、发布版本、模块等页面的搜索。
- 优化了归属不同经办人的子父任务卡片在筛选后的显示。
- 优化了创建模块时的问题逻辑。
- 扩大了影响版本的选择范围，可选择全部版本。
- 优化了部分报表的轮动条。
- 优化了问题详情的评论显示。
- 优化了统计图的版本维度，可选择归档版本。

### 修复

- 修复了富文本粘贴网络图片时数量错误的问题。
- 修复了关闭冲刺的时候，燃尽图问题数量重复计算的问题。
- 修复了统计图版本迭代为空时报错问题。
- 修复了工作日历非节假日计算bug。
- 修复了故事点统计的状态颜色错误。
- 修复了高级筛选中填入不存在用户还能查出数据的错误。
- 修复了由于状态脏数据导致创建看板报错问题。
- 修复了冲刺报告图无法翻页问题。
- 修复了待办事项修改史诗名称，同步更新所有Issue的问题。
- 修复了累计流量图色块与报表中线条的颜色不对应。

### 删除

- 删除了统计图去掉“解决结果”统计类型。
- 删除了累计流量图详情中列选项。
- 删除了史诗燃尽图 & 版本燃尽图 已完成问题链接去掉。

## 持续交付

### [0.14.0] - 2019-03-01

### 新增

- 集群模块新增节点列表，支持查看集群节点的详细信息。
- 实例详情部分新增实例操作日志，支持查看各个实例的详细操作记录。
- 开发控制台页面流水线模块里的持续集成卡片上新增构建报表的入口。
- 部署总览页面新增部署报表的入口。

### 修改

- 优化了实例详情内增减Pod数量的逻辑，Pod数量不可减少至零。
- 优化了开发控制台页面流水线部分的逻辑与自动刷新的问题。
- 将LoadBalancer中添加NodePort的填写输入框变为非必填。
- 修改无分支时的空界面提示文案。
- 优化实例详情中ingress的address值的空值显示。
- 优化了GitLab同步用户的逻辑，在同步前添加了查询操作。

### 修复

- 修复了过滤表内无法叉掉已选选项的问题。
- 修复了网络模块外部IP更新失败的问题。
- 修复了开发流水线模块应用选择框中，“最近”部分的缓存问题。
- 修复了应用管理界面中过滤表筛选的逻辑问题。
- 修复了平台更新用户邮箱后，GitLab同步邮箱失败的问题。
- 修复了不同集群版本StatefulSet的版本不通，Agent Controller兼容不同集群版本时产生的问题。
- 修复了开发控制台的请求问题。
- 修复了pipeline中sonarqube的stage丢失的问题。
- 修复了导出应用时出现的后缀名格式问题。
- 修复了创建环境时由于名称校验引起的报错问题。
- 修复了创建实例时，实例名称为空的问题。
- 修复了开发控制台中流水线内job顺序显示异常的问题。
- 修复了删除存在关联环境的集群时，会先弹出删除指令的问题。

### 删除

- 移除了平台中点击步骤条进行跳转的功能。

## 测试管理

### [0.14.0] - 2019-03-01

### 新增

- 新增了自动化测试框架支持-TestNG。
- 新增了测试执行进度报表（色块展示），用于统计测试用例执行情况，可以筛选得到各个迭代的不同测试循环中的用例执行状态记录。

### 修改

- 优化了测试用例、测试计划、测试执行页面的样式布局和交互体验。
- 优化了测试用例表格和分栏显示。
- 优化了测试计划点击选中版本节点后再创建测试循环直接选中相应版本的流程。
- 优化了导出测试计划表格数据排序，修改为按导出时间排序。
- 优化了测试步骤分页显示。
- 优化了复制测试用例执行步骤后的排序。
- 优化了提示信息的样式。
- 创建用例后，会自动加载对应版本或文件夹用例。
- 优化了测试用例中添加步骤的默认数据，在编辑时直接清除提示语。
- 优化了克隆测试循环时，记住最新版本。
- 优化了测试步骤克隆操作排序。
- 优化了测试计划导出功能数据排序和操作。
- 优化了自定义状态中取色卡组件。
- 优化测试计划页面甘特图的边缘滚动。
- 优化了table的UI样式。

### 修复

- 修复了测试阶段关联用例文件夹版本展示的错误。
- 修复了测试摘要页面表格换页滚动的错误。
- 修复了测试计划页面甘特图中改变时间产生的页面错误。
- 修复了创建缺陷时经办人无法进行搜索的问题。
- 修复了测试计划中拖拽修改特定日期报错的问题。
- 修复了测试缺陷报告特定数据量展示错误的问题。
- 修复自定义状态创建问题。
- 修复代办事项中创建版本时的预计发布日期可以比开始日期早的问题。
- 修复复制子任务的时候没有父任务信息一起复制，导致复制后的子任务没有父级的问题。

## Choerodon微服务开发框架

### [0.14.0] - 2019-03-01

### 新增

**0.14.0显著新增特性**

- 导航栏顶部添加横幅，显示最近系统公告。
- 平台层系统公告中，创建、编辑公告页，公告详情页添加字段“是否在顶部显示”，如果是则显示“结束显示时间”。
- 平台层平台统计新增统计表格，可查看具体时段内的菜单点击次数。
- 平台层平台统计新增导出表格CSV文件功能。
- 平台层可执行程序添加层级字段。
- 平台层可执行程序添加删除功能， 可删除可执行程序。
- 平台层发送设置添加删除功能，可删除触发类型。
- 组织层LDAP添加同步记录，可查看历史同步LDAP记录及失败详情。
- 组织层LDAP添加“uuid属性”字段，测试连接时可查看uuid属性的匹配结果。
- 组织层LDAP添加“同步用户saga每次发送用户的数量”字段。
- 组织层LDAP添加“ldap服务器连接超时时间”字段。
- 组织层组织管理列表页添加图标。
- 项目层项目管理列表添加图标。
- 组织层项目管理支持点击项目名称或者跳转按钮跳转至对应项目。

**控件0.5.1**

- 增加新图标

**boot0.10.3**

- 网页title随页面内容变更而改变。
- WSProvider组件添加取消订阅的逻辑。
- 前端导航栏顶部添加公告的横幅。

**框架的依赖0.9.2**

- liquibase初始化工具支持自定义插入id，只有是整数的id才可以插入，否则自动生成。
- tool-config添加了通过configMap初始化配置的方式。

### 修改

**0.14.0显著修改特性**

- 优化项目名称命名规则。
- 优化登录名命名规则。
- 优化发送设置“应用模板”名称为“默认模板”。
- 优化授权管理页面重定向地址支持跳转。
- 优化系统公告中，删除已发送公告后的提醒弹窗。
- 优化修改组织、项目头像及上传时的名称为“图标”。
- 优化Root用户设置添加用户为选择用户的形式。

**控件0.5.1**

- Form.Item验证为error时不隐藏后缀图标。
- Table过滤失去焦点后不清空。
- Table过滤的清空icon在有内容时就显示。
- Table中过滤的确认按钮固定在选择框底部。

**boot0.10.3**

- 优化收到websocket站内信请求后的逻辑，减少了站内信接口请求次数。

**框架依赖0.9.2**

- 优化了liquibase初始化数据库每个groovy表都要建立jdbc连接的问题。

### 修复

**0.14.0显著修复特性**

- 修复站内信接口请求次数太多的问题。
- 修复系统公告富文本编辑器显示异常的问题。
- 修复项目层任务详情中，创建任务跳转异常的问题。

**boot0.10.3**

- 修复ie不兼容新的dashboard的问题。
- 修复点击总数超过统计个数不发送菜单统计请求的问题。

**框架的依赖0.9.2**

修复了sqlserver数据库，如果#列为空报incorrect syntax的错误。