# Changelog

本文档记录了Choerodon 0.15.0 中 **知识管理、敏捷管理、微服务开发框架、持续交付、测试管理**等功能的优化和BUG修复记录。

## 知识管理

### [0.15.0] - 2019-04-01

### 新增

- 新增页面`创建`按钮，可快速创建新页面。
- 新增空间弹出框全部空间列表分页
- Wiki空间可以修改名称。

### 修改

- 优化了空间弹出框查询全部空间的性能问题。
- 优化了匿名用户登录wiki系统无权限访问匿名分享文章的功能。

### 修复

- 修复了用户未加入的组，XWikiAllGroup不能访问wiki系统的问题。
- 修复了wiki权限分配错误的问题。
- 修复了wiki首次登陆不要跳转$user。
- 修复了项目名称修改，查询不到项目下wiki文档的问题。
- 修复了访问页面报错的问题。

## 敏捷管理

### [0.15.0] - 2019-04-01

### 新增

- 在组织层中，新增优先级自定义以及按照实际的顺序排列。
- 新增问题管理的高级搜索功能。
- 新增问题的导入、导出。
- 新增活跃冲刺看板在制品限制。

### 修改

- 优化搜索查询时，对有值列表的字段进行字段的显示。
- 问题管理支持自定义筛选显示的字段。
- 优化待办事项的排列以及显示性能。
- 在故事中创建子任务时，页面中会显示故事信息。
- 优化问题详情页，登记工作日志的必填项提示。
- 只允许自己和项目所有者才能修改报告人。
- 部分页面样式和报表优化。

### 修复

- 无泳道看板，取消收起功能。
- 修复快速搜索时后端sql报错问题。
- 修复问题详情页问题链接同一关系可以关联同一问题多次的问题。
- 修复燃尽图和待办事项中的剩余问题数/剩余时间数不相符的问题。
- 修复待办事项中版本的问题计数问题。

## 持续交付

### [0.15.0] - 2019-04-01

### 新增

- 部署流水线模块新增自动部署功能，支持预设应用部署所需元素来创建自动部署任务。
- 项目设置模块新增组件设置功能，目前支持创建 Docker 仓库与 Helm 仓库以供项目中的应用选择。
- 项目层创建应用与编辑应用页面新增高级设置功能，支持修改默认的Docker仓库与Helm仓库。

### 修改

- 优化了Values组件的diff效果，支持切换编辑器模式来对比查看代码行的 增、删、改。
- 优化了应用与环境权限分配模块，被分配权限的项目成员在 gitlab 中的角色统一改为developer。
- 优化了平台里执行创建操作时出现熔断后的报错提示。
- 优化了组织层的集群列表的显示。
- 优化了组织层集群的删除逻辑，仅能删除没有关联环境的集群。
- 优化了实例中操作日志页面的显示。

### 修复

- 修复了导入应用时，选择某些模板进行导入后会缺少Dockerfile的问题。
- 修复了分支界面内的没有权限时的报错信息不当的问题。
- 修复了agent与devops-service已断开连接但集群仍然显示正常的问题。
- 修复了网络编辑中IP选择器的问题。
- 修复了操作实例时提示信息不当的问题。
- 修复了部署流水线中切换顶部环境，并进行页面跳转后出现的问题。
- 修复了构建报表部分pipeline里点击重试按钮错误跳转的问题。
- 修复了组织层集群页面的分页问题。

### 删除

- 移除了删除失败应用的功能。
- 移除了停用应用的限制：不能停用有关联实例的应用。

## 测试管理

### [0.15.0] - 2019-04-01

### 新增

- 新增执行详情中创建缺陷时关联故事的功能。
- 新增测试计划中和测试循环下的测试阶段拖拽排序功能。
- 测试用例的筛选维度新增按标签筛选。

### 修改

- 优化删除版本操作对于测试数据的风险提示。
- 优化测试用例导入功能。
- 优化测试循环克隆操作对于时间的处理。
- 优化测试计划页面显示细节。

### 修复

- 修复在测试循环中进入执行详情后翻页错误的问题。
- 修复自动化测试中报告过长导致的数据库存储错误。
- 修复测试计划树状图中与右侧详情进度条不一致的问题。
- 修复测试用例跳转链接错误的问题。
- 修复测试计划中无法更新指派人字段的问题。
- 修复执行详情中新建缺陷失焦的问题 。

## Choerodon微服务开发框架

### [0.15.0] - 2019-04-01

### 新增

**0.15.0显著新增特性**

- 组织层新增应用页，组织管理员可以创建应用，应用分为普通应用、组合应用，组织管理员可以根据需求向组合应用添加应用。
- 平台层新增项目类型页，平台管理员可以自定义项目类型。
- 组织层新增组织信息页，组织管理员可以在这里修改组织信息。

**控件0.5.3**

- 增加新图标
- input输入到达字符数量限制时显示提示。
- Modal添加disableOk和disableCancel属性。
- TreeNode添加wrapper属性。
- IconSelect增加showAll属性

**框架的依赖0.9.3**

- 添加mybatis模块。
- 添加redis模块。
- 添加hap的message模块。

**框架的依赖0.10.0**

- spring-boot升级到2.0.6.RELEASE。
- spring-cloud升级至Finchley.SR2。
- 添加mybatis模块。
- 添加redis模块。
- 添加hap的message模块。

### 修改

**0.15.0显著修改特性**

- 优化事务实例加载缓慢的问题。
- 优化平台菜单点击数导出文件显示信息，添加统计时间范围，显示点击数为0的菜单。
- 优化平台统计中导出csv按钮的位置。
- 优化事务实例中圆圈的数字为`完成数/总数`。

**控件0.5.1**

- input输入到达字符数量限制时显示提示。

**boot0.10.4**

- 更新 less 编译器到 3.9.0

**框架依赖0.9.3**

- 状态机添加创建实例接口。
- 修改liquibase初始化工具满足hap需求。

**框架的依赖0.10.0**

- 状态机添加创建实例接口。
- 修改liquibase初始化工具满足hap需求。

### 修复

- 修复ldap同步历史显示信息异常的问题，不显示当前正在同步的同步记录信息。