# Changelog

本文档记录了Choerodon 0.16.0 中 **知识管理、敏捷管理、微服务开发框架、持续交付、测试管理**等功能的优化和BUG修复记录。

## 知识管理

### [0.16.0] - 2019-05-08

### 修改

- 优化删除收藏夹后续动作，当要删除收藏夹时，可以选择将收藏的页面移动到其他收藏夹。
- 空间的最近空间活动改成异步加载。
- 优化操作体验，wiki空间管理，处理失效的地址失效，不能点击。
- 优化从猪齿鱼的项目链接到空间无页面显示。
- 优化操作体验，评论为空，点击“添加评论”后应该给相应的提示。

### 修复

- 修复旧空间为异步加载。

## 敏捷管理

### [0.16.0] - 2019-05-08

### 新增

- 新增项目群ART设置，支持创建、修改、开启、停用ART，以及ART下的PI列表的展示。
- 新增项目群特性列表，包括计划模式和查询两种模式，并且支持创建特性。
- 新增项目群看板，支持特性的移动、展示等。
- 新增项目群看板的配置，包括列与状态的配置。
- 新增项目群项目设置，支持修改项目编码。
- 新增项目群ART日历，支持查看正在进行中的ART的PI规划以及PI下的冲刺规划。
- 新增项目群PI目标，包括列表和卡片两种模式，支持创建、修改、删除、查询PI目标。
- 新增项目群的team中的story可以关联待处理或处理中状态的feature。
- 项目群中开启PI后，为项目群中的每个team同步生成sprint，同时不允许删除、创建新的sprint。
- 创建问题/编辑问题页面支持自定义字段的应用。

### 修改

- 项目成员可以在项目首页查看未分配的任务，支持分页。
- 当一个故事下的子任务被移动到下一个冲刺中，会记住之前的状态。
- 优化部分页面样式。
- 优化部分报表。

### 修复

- 修复史诗报告中不同维度下数据的展示。
- 修复问题管理中根据名称搜索不准确的问题。
- 修复5.1节假日调整问题。

## 持续交付

### [0.16.0] - 2019-05-08

### 新增

- 部署流水线模块新增流水线的功能，支持在流水线中创建多个阶段，且每个阶段中可添加多个任务，包括自动部署任务与人工卡点任务。
- 部署流水线模块新增流水线执行总览页面，支持查看流水线的执行情况、流程详情以及审批历史。
- 部署流水线模块新增部署配置页面，支持在此创建部署配置用于流水线中添加自动部署任务时选择。
- 平台中新增CLI工具，支持使用命令行的方式来执行平台中的页面操作。
- 创建网络页面，网络配置类型为NodePort时，新增了TCP/UDP协议的选择框。

### 修复

- 修复了删除部署错误的网络时会报错的问题。
- 修复了yaml编辑器错误提示的显示问题。
- 修复了自动部署同一版本部署替换至多实例时失败的问题。
- 修复了自动部署任务中手动输入的版本类型无法触发任务的问题。
- 修复了在敏捷管理中创建任务时查询tag失败的问题。
- 修复了在组件设置中创建harbor仓库失败的问题。
- 修复了loadbalancer类型的网络外部ip没有返回的问题。
- 修复了创建应用时编码中间有两个中划线会创建失败的问题。
- 修复了部署应用时未作修改便提交导致的问题。
- 修复了各服务配置configMap没有回扫成功的问题。

### 删除

- 移除了0.15.0版本中的自动部署页面，并将其内置于流水线中添加任务部分。

## 测试管理

### [0.16.0] - 2019-05-08

### 新增

- 新增测试计划中对循环或阶段克隆批量操作功能。

### 修改

- 优化测试计划、测试执行性能问题。
- 优化测试体验，创建测试循环中，时间选择器优化。
- 优化测试体验，测试计划时间条可以前后拖动。
- 优化测试体验，测试计划中编辑阶段允许更改关联的文件夹。
- 优化测试体验，测试缺陷报表排序，根据创建时间由近到远。
- 优化测试体验，测试执行中点击用例详情中的编号到用例时重新打开一个窗口。
- 优化测试体验，测试报表、测试用例中搜索编号允许带前缀。

### 修复

- 修复树状图空数据报错。
- 修复测试执行进度条计数错误。

## Choerodon微服务开发框架

### [0.16.0] - 2019-05-08

### 新增

- 新增项目群管理相关功能，通过项目群管理项目群下的所有子项目，创建项目时可以选择项目分类为项目群，并可在项目群下添加子项目。
- 组织管理查询新增注册时间字段。

### 修改

- 修改角色分配查询用户更新逻辑，同组织下模糊查询，不同组织精确查询。
- 修改打包时进度日常输出。
- 修改对choerodon-ui的版本依赖规则。

### 修复

- 修复ldap同步历史显示信息异常的问题，不显示当前正在同步的同步记录信息。
- 修复ldap分页同步用户可能导致死循环的问题。
- 修复导入用户异常的问题。
- 修复创建应用发送saga，enabled字段为空的问题。
- 修复实例详情拿不到配置信息的问题。
- 修复菜单导出问题。
- 修复ie 11 下样式显示问题。
- 修复前端在CI build阶段卡住的问题。