# Changelog

本文档记录了Choerodon 0.17.0 中 **大规模敏捷、知识管理、敏捷管理、微服务开发框架、持续交付、测试管理**等功能的优化和BUG修复记录。

## 大规模敏捷

### [0.17.0] - 2019-06-03

### 新增

- PM可以在项目群路线图查看3个PI的feature待办事项。
- 项目群成员可以通过公告板查看各个团队以及迭代之间的依赖关系。
- 项目群完成PI时，将自动完成PI下的sprint，team前端接受到提示。
- 项目群-项目设置可以查看项目信息。
- 项目群可以根据工作日历查看工作时间。
- 项目群feature管理列表功能升级、可以进行高级搜索。
- 特性查询模式下支持排序。
- 项目群看板添加快速搜索。

### 修复

- 修复史诗筛选的PI显示BUG。
- 修复ART列表时间显示BUG。

## 知识管理

### [0.17.0] - 2019-06-03

### 新增

- 新增组织、项目层`知识管理`菜单。
- 新增快速创建、编辑、删除文档。
- 文档支持`Markdown`和`所见即所得`两种编辑风格。
- 文档以树形结构展示，直接拖动排序。
- 文档进行附件上传下载、评论、日志的查看。
- 新增文档目录结构可查看。

## 敏捷管理

### [0.17.0] - 2019-06-03

### 新增

- 用户可以在故事中直接创建缺陷。

### 修改

- 问题关联关系展示关联的测试用例。
- issue导入模板增加模块、冲刺等字段。
- issue详情页面的宽窄样式优化。
- 自定义字段优化相关优化。
- 部分页面样式优化。
- 部分报表优化。

## 持续交付

### [0.17.0] - 2019-06-03

### 新增

- 开发流水线模块新增代码质量页面，支持查看应用在SonarQube中的检测结果与具体详情。
- DevOps报表中新增代码质量图，支持查看应用代码质量中Bug、安全漏洞、代码异味、重复度与单测覆盖率的变化详情。。
- 项目设置模块新增通知设置的功能，支持为各个环境下的删除事件配置通知方式（邮件、站内信或短信）与通知对象。
- 在通知设置中创建通知成功后，删除环境下的实例等资源时，需要输入通知得到的验证码进行删除操作的二次确认。
- 项目设置模块中组件设置页面新增设置项目Harbor仓库类型的入口。
- 部署流水线模块中配置映射部分，新增以YMAL格式进行创建与编辑。
- 部署流水线模块状态为执行中的流水线详情中新增手动终止的按钮，项目所有者可以在此手动终止任何执行中的流水线。

### 修改

- 优化了流水线详情中未执行任务的详情展示。
- 优化了流水线详情内部署任务中实例的跳转功能。
- 优化了流水线详情界面的UI。
- 优化了流水线中无环境权限的项目成员的权限问题。

### 修复

- 修复了在开发控制台中能选择到应用市场导入的应用的问题。
- 修复了创建流水线时人员查询重复的问题。
- 修复了流水线中用户选择器的筛选问题。
- 修复了流水线详情中点击展开按钮查看详情时全部展开的问题。
- 修复了应用导出时部分应用获取chart包失败的问题。
- 修复了从应用市场导入的应用分配权限报错的问题。
- 修复了gitops执行saga事务实例偶尔会卡住的问题。
- 修复了创建应用的saga事务处理逻辑中，偶现更新应用失败的问题。
- 修复了gitops中对象的annotation没保留的问题。

## 测试管理

### [0.17.0] - 2019-06-03

### 新增

- 自动化测试新增 TestNG + Selenium框架。
- 需求追踪性报表新增冲刺、版本字段展示、筛选。


## Choerodon微服务开发框架

### [0.17.0] - 2019-06-03

### 新增

**0.17.0显著新增特性**

- 新增创建角色选择权限界面，权限返回信息以菜单分组。
- 初始化菜单使用excel通过sagaTask初始化。
- 项目群和项目禁用时，禁用对应的关系。
- 请求header 同时加入Jwt_Token 和 Authorization，支持平滑升级。
- asgard-service 通过 spring 提供的DeferredResult 实现长轮询服务端推送消息。
- 后端服务choerodon-starter-mybatis-mapper依赖 更换 为choerodon-starter-mybatis依赖。

**框架的依赖0.11.0**

- 新增mybatis模块，采用依赖的方式使用common mapper。
- 新增Actuator模块，实现一些微服务通用数据的提取。
- 新增Message模块，实现了redis和rabbit的消息队列和订阅机制。
- 新增Redis模块，实现了基于redis的缓存机制。
- 新增Maven插件，实现编译时的一些数据提取。

### 修改

**0.17.0显著修改特性**

- 前端页面按照不同服务进行重新拆分。
- 修改角色管理页面按角色进行筛选。
- 修改应用管理及维护组合应用页面。
- 修改项目管理页面风格。
- 修改消息通知页面为右侧滑出展示。
- 修改菜单结构。
- gateway-helper 合并到 api-gateway。
- 发送消息修改为优先根据设置的自定义发送类型发送。

**框架的依赖0.11.0**

- 完善单元测试提高测试覆盖率。
- 实现长连接代替轮训访问 asgard-service，优化性能。

### 删除

- 分页查询移除PageRequest，不再支持前端传字段自动排序。
- 移除gateway-helper，gateway-helper 不再进行更新。