# Changelog

本文档记录了Choerodon 0.18.0 中 **知识管理、敏捷管理、微服务开发框架、持续交付、测试管理**等功能的优化和BUG修复记录。

## 知识管理

### [0.18.0] - 2019-07-1

### 新增

- 支持版本回滚以及版本对比。
- wik空间中文章全部迁移到知识管理中。
- 文档可以进行链接的分享。
- 支持word的导入，导入后支持预览。
- 页面支持导出pdf。

### 改变

- 删除空间/页面/评论API调整权限。
- 文章的保存优化。
- 编辑处理的优化。
- 问题关联文档修改为关联知识文档。

### 修复

- 修复保存文章时会将名称更改为上一篇文章名的bug。
- 修复知识管理中表格单元格合并后显示错乱的bug。

## 敏捷管理

### [0.18.0] - 2019-07-1

### 新增

- 故事地图重构，主要包括：支持新问题类型feature的规划；支持规划所有的故事；只显示无泳道与版本泳道。
- 在故事下可以快速创建子任务。
- 新增人员类型的自定义字段。
- 新增自定义字段修改的活动日志。

### 改变

- 优化部分接口性能。
- 对于平台中已经停用的用户，人员列表不再显示。
- 父任务可以看到所有子任务状态的进度条。
- 部分页面样式优化。
- 部分报表优化。

### 修复

- 修复问题导入描述字段特殊字符报错。
- 修复版本名称为空的版本也可以创建的BUG。


## 持续交付

### [0.18.0] - 2019-07-01

### 新增

- 部署流水线模块流水线部分新增站内信消息用于通知流水线相关人员去执行对应的操作。
- 部署流水线模块流水线详情页面新增流水线的状态显示与对应的操作按钮。
- 部署流水线模块流水线管理界面与总览界面新增“快速搜索”和“与我相关”的筛选框。
- 部署流水线模块新增部署配置功能，支持在此创建部署配置用于应用部署或创建自动部署任务时选择。
- 部署流水线模块实例部分新增实例关联的网络和域名的界面，支持在此创建和查看与此实例相关的网络和域名。
- 部署流水线模块创建证书页面新增上传证书的模式选择，并新增了对证书文件的校验。
- 部署流水线模块环境总览页面GitOps日志部分，新增重试GitOps的按钮。

### 修复

- 修复了ConfigMap传递值为空的问题。
- 修复了开发控制台页面工作台中分支的查询问题。
- 修复了Redis容器shell里面进入redis命令行，格式有误的问题。
- 修复了流水线失败后点击重试引起的问题。

### 优化

- 优化了开发流水线模块代码质量页面SonarQube的查询。
- 优化了开发流水线模块创建分支的操作。
- 优化了部署流水线模块流水线部分的权限问题。
- 优化了实例界面的查询速度。
- 优化了从GitLab和Github导入应用时只导入master分支的问题，现在会默认将所有分支导入。
- 优化了应用市场中应用已发布版本的查询速度。

### 移除

- 移除了流水线部分的部署配置，将其置于了部署流水线模块之中。

## 测试

## [0.18.0] - 2019-07-1

### 新增

- 新增自动化测试列表页自动刷新功能。

### 改变

- 优化测试用例详情默认展开。

### 修复

- 修复色块报表空数据异常。
- 修复测试计划中测试执行排序异常。


## Choerodon微服务开发框架

### [0.18.0] - 2019-07-1

### 新增

**0.18.0显著新增特性**

- 修改密码菜单新增gitlab修改仓库密码入口。
- 应用管理添加创建和查看token功能，以便于在feedback中识别应用身份。

**控件0.7.0**
- <pro>DataSet: Field新增lookupAxiosConfig属性，用于适配lookup请求的配置。
- configure: 增加全局配置新属性。
- <pro>DataSet: 属性transport支持钩子。
- <pro>TextField: 更新float labelLayout状态下，禁用时的样式。

**boot0.18.0**
- 增加outward的config配置用于页面配置（无权限控制方案）
- 将组织注册的邮件黑名单列表由config配置改为环境变量配置
- 增加在c7n环境中使用pro的一些基本configure。
- 增加axios的data in判断来便于定位错误。
- 增加content组件中backpath为true时调用goback方法的功能。

### 修改

**0.18.0显著修改特性**

- 优化用户信息显示样式。  
- 登录页去除跳转手机端页面。
- 优化任务明细排序方式：优先按状态排序。


**控件0.7.0**

- <pro>Table: 优化空数据显示。

**boot0.18.0**

- 加回HAP中只展示主体部分的页面（withoutsider.html）。

### 修复

- 修复菜单分析数据显示异常的问题。

**控件0.7.0**

- <pro>Table: 修复过滤条placeholder始终显示的问题。
- <pro>DataSet: 修复提交响应值为空时报错的问题。
- <pro>DataSet: 修复indexChange触发的时机问题。
- <pro>DataSet: 修复query事件查询参数不正确的问题。
- <pro>DataSet: 修复级联子数据源数据无法提交的问题。
- <pro>DataSet: 修复ignore为clean的多语言字段无法正确提交的问题。

**boot0.18.0**

- 修复MenuStore中的菜单遗漏问题。
- 修复下拉框和Action组件某些情况下无法打开的问题。
- 修复c7n共用cache-route造成的问题。
- 修复MenuStore中由于缓存数据导致的菜单点击统计报错的问题（只保留一个版本）。

### 删除
- 移除平台层对项目分类的维护。