# Changelog

本文档记录了Choerodon 0.19.0 中 **知识管理、敏捷管理、微服务开发框架、持续交付、测试管理**等功能的优化和BUG修复记录。

## 知识管理

### [0.19.0] - 2019-10-28

更名为`知识库`，项目层知识库入口在`协作`功能模块下，组织层知识库可在顶部菜单栏进入。

### 新增

- 支持文档移动：单个文档移动和父级文档移动
- 支持文档定时保存为草稿，异常退出可恢复
- 支持文档设置个人的默认编辑模式
- 支持文档全文检索，按照关键词权重返回结果列表
- 项目层可以查看组织层的文档
- 文档支持全屏查看和编辑
- 文档版本记录增加标题信息
- 首页增加查看最近更新的文档列表

### 改变

- 优化文档链接分享操作
- 文档加载性能优化

### 修复

- 修复删除文档的脏数据

## 敏捷管理

### [0.19.0] - 2019-10-28

敏捷管理中的待办事项、问题管理和发布版本合并移动至`协作`模块中的工作列表；项目群和故事地图移动至`协作`模块下同名功能；活跃冲刺移动至`开发`模块中，并更名为迭代规划；报告工作台不再使用。

### 新增

- 新增在用户故事泳道中点击名称查看详情。
- 合并issue服务，状态机服务，基础服务到agile服务。
- 新增对故事类型转换的限制，如果有子任务，只能转成任务。
- 新增附件图片、pdf、word、excel等文件的预览。
- 创建bug类型的模板，给出初始的模板。

### 改变

- 全局样式调整。
- 优化下拉选择时数据的加载。
- 故事地图重构后操作优化。
- 创建问题自定义字段加载优化。
- 工作列表的待办事项UI优化。
- 问题管理列表搜索重构。

### 修复

- 修复修改父任务同时修改冲刺。
- 修复当成员任务全部为子任务时，未正确返回人员信息。
- 修复问题中修改问题模块，模块复选框选中状态还是上一次的状态。
- 修复模块管理中删除模块时移动问题无法获取其他模块。
- 修复问题设置状态页面筛选状态列表为空时不能创建状态。
- 修复详情页修改了优先级，列表页没有更新。

## 持续交付

### [0.19.0] - 2019-10-28

开发流水线中的代码仓库、分支、标记、合并请求、持续集成、代码质量移动至`开发`模块下的代码管理，开发控制台不再使用。

部署流水线中的环境管理和部署配置移动至`部署`模块下的环境配置；应用部署移动至新版应用部署下的部署页面；实例、资源移动至应用部署下的资源页面；流水线移动至应用部署下的同名页面。

### 新增

- 新增“应用服务详情”界面，其中包含了某个应用服务的版本、权限分配情况以及该服务共享设置的详情。
- 新增应用服务“共享设置”的功能，允许项目所有者将应用服务的特定版本或某个版本类型共享给组织下其他项目。
- 新增以其他应用服务的代码库为模板以此来创建一个应用服务的功能。
- 新增批量导入组织内共享的应用服务至该项目下的功能。
- 环境配置模块新增环境详情界面，其中包含了对应环境下的GitOps日志、部署配置以及权限分配情况。
- “部署”页面新增部署记录的列表，其中包含了手动部署以及流水线部署产生的所有记录及其详情。
- “资源”模块新增“自定义资源”界面，支持对非c7n-release类型的YAML文件进行添加和管理。

### 修复

- 修复了实例Code唯一性校验的问题。
- 修复了devops-service服务多实例情况下，界面部署找不到gitops文件的问题。
- 修复了已停用用户在之前的应用服务与环境中权限移除问题。
- 修复了过滤表中点击Title排序报错的问题。
- 修复了环境对应的gitops库不存在时，删除环境报错的问题。
- 修复了搜索不存在的应用版本时出现500状态码的问题。
- 修复了应用服务关联私有harbor配置，部署时未创建授权secret的问题。
- 修复了实例删除后建立同名实例时，网络关联的实例没有关联更新的问题。
- 修复了域名从普通协议切换到加密协议无效的问题。

### 优化

- “应用服务”模块优化了创建应用服务的步骤，支持快速地创建一个应用服务
- 将组件设置中的“通知设置”整合至环境配置模块环境详情界面中的“资源安全设置”，支持为对应环境下的删除事件配置通知方式（邮件、站内信或短信）与通知对象
- 优化了“应用服务部署”页面，支持在一个页面快速完成实例的部署
- 优化了原实例界面的“升级实例”功能，改为“变更实例”，支持回滚或升级至实例对应应用服务的任一版本
- 优化了实例界面“重新部署”的功能逻辑
- 优化了CD流水线的记录总览界面，将其融入部署记录列表之中
- 将组织层DevOps设置中的“集群管理”移至项目层的“部署”模块
- 将组织层DevOps设置中的“证书管理”移至项目层的“部署”模块

### 移除

- 移除了组织层的应用模板。若想选择模板创建应用服务，可在应用服务界面点击“导入应用服务”的按钮，并选择：从GitHub导入-系统预设模板
- 移除了项目设置内的组件设置页面，支持在组织层、项目层、应用服务层的仓库设置或高级设置中直接修改默认仓库
- 移除了项目设置内的通知设置，并将其移至环境配置模块
- 移除了项目层的应用市场模块
- 移除了手动部署中“替换实例”的功能，需在实例界面“变更实例”进行实例的回滚或升级

## Choerodon微服务开发框架

### [0.19.0] - 2019-10-28

### 新增

**0.19.0显著新增特性**

- 新增平台层用户管理，以便于平台管理员能够管理全局的用户。
- 新增系统主题色配置，以便于个性化系统外观。
- 新增组织管理员菜单，以便于快速添加组织管理员。
- 新增团队成员，以便于管理项目下的全部用户。
- 菜单管理新增精确到tab。

### 修改

- 优化系统导航栏，以组织维度显示个人相关的项目和知识文档。
- 平台管理入口移入用户头像下的菜单。
- 将原平台角色分配移入平台层用户管理。
- 将原任务明细、可执行程序、执行记录合并为任务管理，降低操作复杂度。
- 优化角色管理的权限控制，方便用户配置接口权限和路由权限。
- 系统设置划分为通用设置和安全设置。
- 将原发送设置、邮件模板、站内信模板、短信模板合并为消息服务，提升使用便捷度。
- 将原邮箱配置、短信配置合并至通知配置。
- 将原组织设置移入管理中心。
- 将原组织层用户管理和组织角色分配合并为用户管理。
- 将原组织层组织信息、ldap设置、工作日历、仓库合并入通用设置。
- 将原组织层密码策略、客户端并入安全设置。

### 删除

- 移除项目管理。
- 移除项目层事务实例。
- 移除首页dashboard。
- 移除平台管理的仪表盘配置。
- 移除平台层的路由管理。
