# Changelog

本文档记录了 0.20 中协作、开发、部署、测试以及平台管理等功能的增加、优化和BUG修复记录。

## 平台管理功能

### [0.20.0] - 2019-12-30

### 新增

- 项目层添加webhook设置功能，项目管理员可以自定义hook配置。
- 平台层添加webhook日志功能，记录webhook的发送记录，方便管理员审计。
- 平台层消息服务添加配置webhook发送设置，包括是否启用webhook发送方式设置、webhook模板内容定义。
- 平台层消息服务添加消息类型的类别划分。
- 平台层任务管理支持查看可执行程序，开发者可以直接查看平台层的可执行程序及其参数信息。
- 组织层任务管理支持查看可执行程序，组织管理员可以直接查看组织层的可执行程序及其参数信息。
- 平台层添加LOV配置，以便于开发人员能快速进行LOV选择框的配置。
- 平台层添加快码维护，以便于开发人员能够快速进行下拉选择框的配置。
- 平台层添加描述维护，以便于开发人员能够快速进行多语言维护，目前仅支持中文和英文。
- 组织层用户管理新增LDAP同步设置的功能，支持手动同步与自动同步LDAP用户的操作，且能在此查看手动同步与自动同步的记录。
- 项目层新增通知设置，统一管理项目下各类消息通知事件的发送方式及通知对象，包括敏捷消息、DevOps消息、资源删除验证。

### 优化
- 优化了平台层优化消息服务页面，以树形结构展示使操作更加便捷，移除多余的消息模板，一种消息类型的不同发送方式分别只对应一个模板。
- 优化了管理中心与项目设置中通用模块的结构，仓库配置作为单独维护模块，使用户的操作更加便捷。
- 根据消息通知的结构变化，同步优化了“个人中心-接收设置”的结构与消息类型。

### 修复
- 修复了Chrome79.0.3945.79版本浏览器兼容性问题。

## 协作

### [0.20.0] - 2019-12-30

### 新增
- 支持通过点击待办事项上的经办人筛选问题。
- 故事地图支持在需求池按无版本筛选。
- 筛选问题支持选择历史版本和历史冲刺。
- 支持查看最近的知识活动。
- 支持回收站功能。

### 优化
- 优化了任务中的子任务，支持关联知识。
- 优化了看板默认泳道配置调整为经办人。
- 优化了配置看板在无冲刺时也可以配置。
- 优化了侧栏顶部，去除文字说明。
- 优化了字段解释icon、说明，统一样式。
- 优化了字体颜色以及字号大小，统一样式。


### 修复
- 修复了问题详情知识链接跳转问题。
- 修复了问题列表的优先级字段缺失。
- 修复了问题详情快速创建子任务多次点击会重复创建。
- 修复了项目群公告板未关联子项目报错。
- 修复了知识库部分白页的情况。

## 测试

### [0.20.0] - 2019-12-30

此次发布的新版本相较于上一版本会有较大的改动，本次更新对其结构和功能进行了大幅度的调整和优化：
计划和执行合并，便于测试人员更加直观的进行测试计划管理。
- 新版测试计划支持自动同步用例，便于用户快速同步用例到计划的执行。
- 测试计划支持根据自己的需要从用例更新内容到测试计划。
- 测试计划添加测试总览，以便于测试人员快速了解计划的测试状态。
- 移除自动化测试和用例的关联。
- 移除用例与版本的强关联。
- 去除用例文件夹的层级约束，用户可以创建无限层级的用例文件夹，使用户可以更加灵活的划分用例。

## 开发

### [0.20.0] - 2019-12-30

### 新增
- 应用服务模块新增删除停用状态应用服务的功能，支持删除停用后的应用服务。
- 代码管理模块选择应用服务的下拉框中新增“最近使用”的快捷方式。
-  “代码管理”模块复制仓库地址，新增支持复制仓库的SSH地址。
- 资源模块“实例视图-环境层”中新增部署配置的Tab页，支持有环境权限的人员在此处创建与管理部署配置。
- 流水线列表中新增查看该条流水线所有执行记录的快速入口。
- 项目层-通知设置中，新增敏捷消息、DevOps消息、资源删除验证的Tab页，支持在此页面统一管理项目下各类消息通知事件的发送方式及通知对象。

### 修复
- 修复了导入应用服务时服务编码、名称长度限制问题。
- 修复了权限分配界面为特定成员分配权限时必选一个成员的问题。

### 优化
- 优化了应用服务名称的字符限制，将其放宽至40个字符。 

## 部署

### [0.20.0] - 2019-12-30

### 新增
- 集群模块新增“组件管理”功能，支持管理CertManager组件的安装与卸载。
- 集群模块新增PV管理的功能，支持在集群中创建与管理NFS与HostPath类型的PV。
- 手动部署界面新增资源配置模块，支持在部署时就为对应的实例创建好关联的网络和域名。
- 资源模块新增PVC管理的功能，支持在环境中创建与管理PVC。
- 资源模块实例层中Pod详情页新增删除Pod的功能，支持删除实例中的某个Pod。
- 资源模块实例层中查看实例事件时新增全屏查看的功能。

### 修复
- 修复了密文在环境库中为明文存储的问题。
- 修复了导入共享服务所属项目数据不一致的问题。
- 修复了人工触发流水线中，第一个阶段为空时，执行失败的问题。
- 修复了人工触发中。

### 优化
- 资源模块实例层中，优化了实例状态与其对应的Command状态的逻辑。
- 优化了项目层的Harbor库默认置为私有。
- 优化了手动部署后的页面跳转。
- 优化了分支列表中的排序问题。
- 优化了环境配置中的状态及其对应的操作，支持删除停用与未连接状态的环境。
- 优化了资源模块中配置映射与密文的状态显示。



