# Changelog

本文档记录了 0.21 中协作、开发、部署、测试以及平台管理等功能的增加、优化和BUG修复记录。

## 平台管理功能

### [0.21.0] - 2020-03-13

### 新增

- “个人中心”新增“重置Gitlab密码”的功能，支持在此一键重置GitLab密码。
- 平台管理模块，新增“平台概览”页面，支持查看平台中在线人数统计图、平台总人数统计图、事务执行情况、Choerodon邮件发送情况、系统公告以及平台层的操作记录。
- 平台管理-角色管理，新增完善了平台层、组织层以及项目层各个菜单下的接口权限，支持为自定义角色分配菜单下更细的操作权限。
- 组织层-管理中心，新增“组织概览”页面，支持查看组织总人数统计图、项目情况、集群情况、应用服务概览、项目部署情况、事务执行情况以及组织层的操作记录。
- 项目层运营模块，新增“事务管理”页面，支持项目人员查看项目层事务实例的运行情况。
- 项目层-通知设置中，新增敏捷消息、DevOps消息、资源删除验证的Tab页，支持在此页面统一管理项目下各类消息通知事件的发送方式及通知对象。
- 新增“添加用户角色”、“停用组织”、“重置密码”、“导入用户”等事件的消息通知。

### 优化

- 优化“忘记密码”的流程，Choerodon将直接为用户的邮箱发送重置密码的链接，用户可直接通过点击链接来修改密码。
- 优化Root用户的权限，Root用户默认拥有平台中所有组织所有项目的权限。
- 优化组织管理员的权限，组织管理员默认拥有对应组织下的Root权限。
- 优化组织层与项目层导入用户的Excel模板，添加了角色编码的提示，与角色编码可选的功能。
- 优化添加角色后的消息通知对象，改为通知“角色被添加者”。
- 优化平台层的树状结构的显示，支持左右拖动增加其宽度。

### 修复

- 修复“平台管理-角色管理”中创建项目层自定义角色后，因为未选GitLab角色标签而导致的问题。
- 修复平台层的API统计偶现无数据的问题。

## 敏捷协作

### [0.21.0] - 2020-03-13

### 新增

- 配置看板支持删除状态。
- 导入问题支持导入父子级关系，用户可以在导入故事或任务时同时导入子任务。
- 敏捷消息通知支持邮件方式。
- 支持创建多个知识库。
- 支持知识库设置公开范围。
- 知识库支持设置文档模板。
- 支持基于模板创建知识库或者文档。
- 知识库支持复制文档。
- 支持从回收站恢复知识库。


### 优化

- 优化敏捷看板性能。
- 优化工作列表性能。
- 优化配置看板状态设置为已完成保存不生效的问题。
- 优化待办事项批量拖拽问题数量显示。
- 优化问题链接页面样式。
- 优化自定义字段页面样式。


### 修复

- 修复故事地图全屏显示菜单栏的问题。
- 修复迭代计划工作台刷新后无数据的问题。
- 修复问题详情剩余预估时间名称显示错误的问题。
- 修复故事地图史诗特定情况无法查看评论的问题。
- 修复设置敏捷模块负责人显示undefined的问题。
- 修复知识库全屏显示菜单栏的问题。
- 修复由于wiki迁移至知识库造成的操作历史、版本对比显示异常的问题。
- 修复删除知识库文档未删除与敏捷问题的关联的问题。

## 测试

### [0.21.0] - 2020-03-13

### 新增

- 测试计划支持计划日历，测试人员可规划测试用例的执行时间。
- 测试用例支持移除问题链接。
- 测试计划支持查看“我的执行”，测试人员可以只查看指派给我执行的测试用例。

### 优化

- 优化测试执行历史记录。

### 修复

- 修复测试用例步骤分页错误的问题。
- 修复导入测试用例模板字段冗余的问题。

## 开发

### [0.21.0] - 2020-03-13


### 修复

- 修复持续集成pipeline中，lastest分支每页都有的问题。

### 优化

- 优化应用服务的创建过程的超时逻辑，避免了一直在处理中的情况，从而导致应用服务无法删除。
- 优化拉取共享应用服务镜像。

## 部署

### [0.21.0] - 2020-03-13

### 新增

- “集群管理-组件管理”模块，新增"监控组件"卡片，支持管理监控组件（Prometheus、Grafana、AlertManager）的安装与卸载。
- 集群模块新增“集群监控”功能，在已安装监控组件的前提下，支持查看集群下所有节点的资源使用情况。
- 集群下每个节点的详情页，新增“节点监控”功能，在安装监控组件之后，支持查看各节点的资源使用详情以及该节点下所有Pods的资源使用情况。
- 集群模块新增“健康检查”功能，集成Polaris组件，支持检测出集群与环境中可能影响稳定性、可靠性、可伸缩性和安全性的配置问题。
- 实例视图-环境层新增环境“健康检查”的功能，支持检测出各个实例配置文件中可能影响稳定性、可靠性、可伸缩性和安全性的配置问题。
- 资源视图-环境层新增“提交同步情况”的显示，支持在此查看对应环境的提交同步情况与GitOps错误日志。
- 部署模块、实例视图以及资源视图新增“批量部署”的功能，支持同时将多个应用服务批量部署至同一环境的功能。
- “实例-运行详情-更多详情”中，新增“YAML格式查看”的功能，支持以YAML格式查看实例配置文件的详情。
- 流水线列表中新增了“部署环境”列，用于展示流水线中包含的部署任务对应的环境。
- PV列表中，“所属集群”栏中新增集群的状态的显示。
- PVC列表中新增了“PV类型”的显示。


### 修复

- 修复实例更新失败后，不能增减Pod的问题。

### 优化

- 优化“实例-运行详情”界面的显示问题，完善了缺失字段的显示。
- 优化创建PV的过程，允许用户直接为其分配权限至特定项目，来避免错误绑定的情况。

### 删除

- 移除“资源视图-网络详情”界面中Pods的CPU与内存使用量的折线图。
- 移除“资源视图-环境层”中的内存与CPU用量排行的列表。

