# Changelog

本文档记录了 0.22 中协作、开发、部署、测试以及平台管理等功能的增加、优化和BUG修复记录。

# 基础功能

### [0.22.0] - 2020-08-16

## 新增功能 

* 组织层“管理中心”新增Webhook配置功能，支持创建钉钉、企业微信、Json类型的Webhook来发送组织层的消息通知； 
* 组织层“管理中心”与项目层“设置-通知”模块新增Webhook执行记录页面，支持查看与重试某条Webhook执行记录； 
* 组织层“管理中心”新增“角色管理”的功能，支持组织管理员在此创建组织层或项目层的自定义角色；
* “平台层-消息服务”中新增组织层与项目层中各个事件对应的钉钉、企业微信、Json类型webhook的默认消息模板； 
* 新增“普通敏捷项目”项目类型，此类项目仅保留了敏捷测试相关的功能，支持项目团队专注使用敏捷协作功能； 
* 新增“运维项目”项目类型，此类项目仅保留了开发部署等DevOps相关的功能； 

## 功能优化 

* 平台概览界面中新增了显示平台中集群状态与数量的情况； 
* “平台管理-邮件日志”中，支持重发“成功”或“失败”状态的邮件； 
* “平台管理-邮件日志” 中，支持自动清除半年前的发送记录； 
* “组织层-用户管理-添加组织用户”、“项目层-团队成员-添加团队成员”时，在搜索出的用户后面，加上了登录名； 
* “平台管理-接口”页面的“权限编码”与“地址”后面加上了快速复制的按钮；

# 敏捷协作 

### [0.22.0] - 2020-08-16

## 新增功能 

* 工作列表-所有 问题 按issue层级展示； 
* 工作列表-所有问题支持批量修改issue； 
* 工作列表-所有问题支持全部字段筛选，包括全部预定义字段、自定义字段； 
* 敏捷看板支持全屏显示； 
* 敏捷看板支持查看多个迭代； 
* 导入问题支持按照任务-子任务、故事-子任务父子层级导入； 
* 导出问题支持按问题层级导出； 
* 敏捷看板支持自定义状态顺序； 
* 敏捷消息添加预置钉钉、企业微信webhook模板 ； 

## 缺陷修复 

* 修复状态机状态删除造成看板异常的问题； 

## 功能优化  

* 待办事项史诗侧栏优化为不显示已完成史诗； 
* 优化子任务详情页：可以直接看到父级任务的概要； 
* 优化敏捷服务权限； 
* 优化导出问题性能问题； 
* 优化待办事项团队成员工作量显示；

### 知识库 

* 知识库文档编辑器npm包升级 

# 代码开发 

### [0.22.0] - 2020-08-16

## 新增功能 

* 开发模块新增“CI流水线”的功能，支持创建多个阶段，且每个阶段中可添加多个任务； 
* CI流水线界面中支持配置添加多种类型的任务，包括：构建、代码检查与自定义任务； 
* CI流水线中新增支持多种常用语言的构建模板：如Maven模板、Npm模板、Go模板； 
* CI流水线界面中支持查看各条CI流水线的执行记录详情； 

## 缺陷修复 

* 修复了导入应用服务时，选择的微服务后端模板中使用命令启动错误的问题； 

# 测试管理 

### [0.22.0] - 2020-08-16

## 缺陷修复 

* 修复创建计划时间校验问题； 
* 修复查看用例详情由于objectnumber造成偶发报错问题； 

# 环境部署 

### [0.22.0] - 2020-08-16

## 新增功能 

* “应用部署-资源-域名”模块，创建与修改域名时，新增支持填写“Annotation”； 
* C7N agent中helm组件由V2升级至V3； 
* 升级部署模块支持的k8s版本至V1.17； 

## 缺陷修复 

* 修复了未登录Grafana时，节点监控页面白屏的问题； 
* 修复了点击实例界面“运行详情-更多详情”偶现白屏的问题； 
* 修复了实例界面运行详情中修改pod数量后进行重新部署，pod能否增减判断错误的问题； 
* 修复了变更实例查询values接口参数的问题； 
* 修复了实例部署超时未发站内信的问题； 
* 修复agent不支持StatefulSet的问题； 
* 修复了修改域名时，端口下拉框中未显示出已有端口的问题； 
* 修复了RegistrySecret在Kubernetes中被删除后，而Choerodon未感知的问题； 
* 修复了集群重置后Pod数据未进行同步的问题； 
* 修复了Polaris扫描的超时机制在查询时不生效的问题； 
* 修复了创建集群的ChoerodonId可能为纯数字字符串的问题； 
* 对一个文件存在多个资源包含PV和PVC的情况做了处理； 
* 修复了集群管理页面，树结构中集群状态排序错乱的问题； 
* 修复了DevOps报表中代码提交图、构建次数图选择时间范围时，数据不准确的问题； 
* 修复了以运行结果为条件搜索部署记录时，未筛除批量部署的问题； 

## 功能优化 

* “应用部署-资源”模块，实例视图与资源视图的环境层级，在环境名称后加上了所属的集群； 
 