# Changelog

本文档记录了Choerodon 0.9.0中**微服务开发框架**、**持续交付**、**敏捷管理**、**知识管理**、**测试管理**等功能的增强、变更等。在此版本中新增了**知识管理**、**测试管理**等功能服务。并对**微服务开发框架**、**持续交付**、**敏捷管理**等服务的功能进行了优化和增强。

值得注意的是在0.9版本中，采用`GitOps`方式重构部署流程，关于GitOps可以参考《[GitOps丨一种实现云原生的持续交付模型](http://choerodon.io/zh/blog/gitops/)》 。

## 知识管理
### [0.9.0] - 2018-08-24
### 新增

- 知识管理页面添加删除空间的功能
- 知识管理界面添加了多语言支持和按钮权限
- 用户登录知识管理服务时自动同步Choerodon平台上的用户基本信息
- 添加知识管理服务编辑器支持markdown语法

### 修改
- 修改知识管理界面的空间列表显示内容
- 修改了知识管理站点`favicon`
- 修改知识管理空间首页内容和布局
- 修改知识管理侧边栏
- 修改知识管理的人员信息页
- 修改知识管理创建页面入口页
- 修改了知识管理通知弹出框的显示内容
- 优化了知识管理页面的加载性能
- 优化了知识管理使用`oauth`认证的性能
- 知识管理页面的空间列表现在也可以显示树形空间结构
- 优化了创建空间过程对用户的状态提示
- 优化了所有更新页的显示

### 修复
- 修复系统使用https时，回调地址错误的问题
- 修复知识管理用户在知识管理中无法退出登录的问题
- 修复了空间名字中带有"."的时候，空间显示错误的问题
- 修复了知识管理设置按钮的权限判断错误的问题

### 删除
- 删除了知识管理头部导航栏的人员列表按钮
- 删除了知识管理中创建空间的功能

## 敏捷管理
### [0.9.0] - 2018-08-24

### 新增

- 版本拖动排序功能：用户可以在版本管理界面、待办事项界面对版本进行拖动排序。
- 史诗拖动排序功能：用户可以在待办事项界面对史诗进行拖动排序。
- 快速搜索排序功能：用户可以在设置中的快速搜索界面对快速搜索进行拖动排序。
- 迭代速度图功能：用户可以通过选择故事点、问题计数、剩余时间查看不同冲刺对应的问题完成比例柱状图。
- 史诗报告功能：用户可以选择不同史诗通过故事点、问题计数、剩余时间查看当前冲刺的已完成、未完成、未完成未预估的问题，同时还可以查看对应的汇总数据。
- 问题统计图功能：用户可以根据经办人、模块、问题类型、修复版本、优先级、状态、冲刺、史诗、解决结果查看项目下的问题统计饼图。
- 问题详情返回功能：用户在任意界面点击问题详情查看后，都可以退回到原页面。
- 新增`agile-service`基于`Spock`编写的单元测试。
- 问题详情中操作添加创建分支功能。
- 修改状态为已完成时生成该状态下的问题解决日志。
- 修改冲刺名称增加长度限制。

### 修改
- `agile-service`消息机制由`Kafka`修改为`Saga`。
- 对版本报告图请求时间过长进行优化。
- 对燃尽图请求时间过长进行优化。
- 待办事项界面样式调整。
- 优化待办事项界面中史诗和版本加载过慢问题。
- 日志处理逻辑重构。
- 版本状态样式修改。

### 修复
- 待办事项界面内存溢出问题。
- 燃尽图数据不一致。
- 累积流图数据不一致。
- 模块管理创建模块后数据展示不一致。

### 删除
- 问题详情左侧窄栏工作日志、活动日志的显示。
- 对史诗及其子任务的累积流图统计信息。


## 持续交付
### [0.9.0] - 2018-08-24
### 新增
- 采用`GitOps`方式重构部署流程，关于GitOps可以参考《[GitOps丨一种实现云原生的持续交付模型](http://choerodon.io/zh/blog/gitops/)》 。
- 增加环境总览相关接口
- `agent`保持原命令模式并实现`GitOps`
- 安装实例插入相关平台标签
- 新增环境总览模块,以便于方便管理某环境的部署相关实体
- 前端api测试

### 改变
- 重写部署实例`values`，支持标准`yml`格式
- 网络多端口支持，`label selector` 支持，`NodePort`类型支持
- 修改网络界面
- 通过填写标签创建网络
- 增加网络的 `NodePort` 类型配置
- 移除网络关联的应用版本
- 未修改配置信息不可重新部署
- 优化各模块数据加载效果
- 修改容器日志选择背景色，和非编辑状态不可复制

## 测试管理
### [0.9.0] - 2018-08-24
### 新增

#### 0.9.0显著新增特性

- 界面增加多语言,可以配合平台进行多语言切换
- 增加仪表盘展示界面
- 执行列表增加快速通过按钮，若测试通过不必点到详情调整执行状态
- 增加循环导出功能，用户可将循环的内容导出为excel
- 增加循环跨版本克隆功能，用户可将测试循环复制到其他版本中复用
- 测试循环详情表格伸缩显示，优化在树状图收起后的表格内容展示
- 增加部分单元测试
- 增加部分`api`测试
- 增加了创建测试用例时名称校验
- 问题编号增加转跳，用户不必切换到敏捷界面查看缺陷
- 用例详情中的执行记录中增加循环转跳，用户可在用例详情中的执行表格中直接转跳
- `用例管理`的默认搜索，不需要选择字段再进行选择了
- `循环详情`界面增加根据人员筛选功能，用户可筛选指派人或执行方
- 关联缺陷时支持转跳方便新建缺陷

### 修改

#### 0.9.0显著修改特性

- 优化了报表、测试循环、测试步骤、缺陷等查询接口
- 事件消息改为saga模式
- 测试状态图标样式变更
- `测试摘要`页面接口整合优化
- `用例管理`页面增加展示内容
- `用例管理`排序去掉多余字段
- 执行详情表格内编辑，降低操作成本
- `用例管理`中测试步骤可表格内编辑，降低操作复杂度
- 优化`报表`页面布局，列宽不会因为展开变动

### 修复

#### 0.9.0显著修复特性

- 修复`测试循环`和步骤分页显示问题
- 修复删除测试用例后的计数不会级联删除的问题
- 修复删除执行后的页面不会全局自动刷新的问题
- 修复执行详情界面宽度兼容错误导致看不到编辑按钮的问题
- 修复了`报表`的分页数据错误的问题

## Choerodon微服务开发框架
### [0.9.0] - 2018-08-24
### 新增

#### 0.9.0显著新增特性

- 新增事务定义，开发者能更好的实现分布式事务，避免了分布式场景下产生数据不一致的问题。
- 新增事务实例，开发者可以查看所有运行的事务，可以查看事务中任务的状态以及状态详情。
- 新增角色标签，平台管理员可以查看标签的说明与层级，角色标签只能在同层级的角色中添加。
- 新增仪表盘配置，平台管理员能设置用于展示的仪表盘卡片。
- 新增仪表盘，用户能在不同的层级使用仪表盘实现信息概览。
- 新增邮件模板，平台管理员和组织管理员可定义发送给用户的邮件内容。
- 新增邮箱配置，平台管理员可设置发件邮箱的信息。
- 新增用户批量导入，组织管理员可以下载导入模板，填写后上传文件批量导入用户数据。

#### 控件0.3.6

- 增加新的图标。

#### boot0.7.1

- 增加可定制化仪表盘功能。

#### 框架的依赖0.6.0

- 新增`choerodonstarterasgard`, 用于支持基于`saga`的数据一致性。
-  `choerodonstartercore`添加了FeignException异常类，用于处理feign调用异常。
- `choerodonstartercore`包添加excel数据转换为list对象工具类。
- `choerodonstartercore`包添加了导出excel 2003的工具类。

### 修改

#### 0.9.0显著修改特性

- API测试优化为在界面上即可进行API测试操作，输入测试数据并查看结果，且支持其他账号的授权。
- 修改`asgard`服务`ci`，`deploy`依赖，修改chart部署服务。
- `asgard`服务优化，`taskInstanc`e的返回值由`map json`修改为`json`。
- API测试中，后端解析dto中的注释，将注释显示在界面。
- 页面优化为第一个input框自动获取光标。

#### 控件0.3.6

- 优化`Switch`开关样式。

#### boot0.7.1

- 滚动条样式优化。
- 升级组件库`choerodonui@0.3.5、react@16.4.1、reactdom@16.4.1`。
- 部分组件的状态迁移到`Store`中。
- `Action`控件传递`props`给内部的`Button`控件。
- `Permission`和`Page`控件增加`onAccess`钩子。

### 修复

#### 0.9.0显著修复特性

- 修复重新部署`oauth`后要清缓存才能登录的问题。
- 修复切换组织/项目后，菜单面板没有收起的问题。
- 修复手机登录页重定向问题。
- 修复`choerodon-ui`国际化显示不正确的问题。
- 修复LDAP同步用户，无法全部同步的问题。
- 修复实例管理部分服务没有配置信息的问题。
- 修复解析权限的时候，可能报重复字段，导致插入失败的问题。
- 修复角色分配界面，移除用户角色可能不发送data的问题。

#### 控件0.3.6

- 修复带字段的过滤，按回车键后tag暂时消失的问题。
- 修复加载图标未置于顶层的问题。
- 修复加载图标与操作图标重叠的问题。

#### boot0.7.1

- 仪表盘若干问题。