# ROADMAP

该ROADMAP是猪齿鱼核心开发团队预期的产品开发计划列表,详细描述了猪齿鱼的未来走向，但随着时间的发展,可能会出现变动。希望通过ROADMAP能够让您获知我们的计划与愿景,如果您有什么更好的意见欢迎在[ISSUE](https://github.com/choerodon/choerodon/issues)中提出。

## 平台基础

- [x] 平台概览
- [x] 组织概览
- [x] 角色管理
- [x] 事务管理
    - [x] 事务定义
    - [x] 事务实例
- [x] Root用户
- [x] 用户管理
- [x] 菜单管理
- [x] 任务管理
- [x] 系统公告
- [x] webhook日志
- [x] 邮件日志
- [x] 通用管理
- [ ] 页面自定义
- [x] 授权管理
- [x] 消息服务
    - [x] 通知配置
    - [x] 接收配置
- [x] 微服务实例
- [x] 接口
    - [x] 接口统计
    - [x] 菜单统计
- [x] Choerodon CLI工具
- [x] 项目类型拆分 
- [ ] 个人工作台 
- [x] 平台用户审计功能 
- [x] 安装工具支持商业版安装 
- [ ] 项目概览
- [ ] 平台数据回收功能
- [ ] 系统多组件事务优化
## 敏捷协作

- [x] 迭代计划
    - [x] 看板管理
      - [x] 配置列和状态
      - [x] 选择泳道
      - [x] 多看板
      - [x] 定义工作日历
    - [x] 迭代工作台
    - [x] 结束冲刺
- [x] 团队成员管理
- [x] 模块管理
- [x] 工作列表
    - [x] 问题类型
      - [x] 史诗
      - [x] 用户故事
      - [x] 任务
      - [x] 缺陷
    - [x] 规划冲刺
    - [x] 待办事项列表
    - [x] 版本管理
- [x] 故事地图
- [ ] 状态机
## 知识库

- [x] 知识库管理
    - [x] 组织知识库
    - [x] 项目知识库
- [x] 文档管理
- [x] 文档分享
## 代码开发

- [x] 应用服务管理
    - [x] 共享应用服务
    - [x] 权限管理
- [x] 代码管理
    - [x] 代码仓库
    - [x] 分支管理
    - [x] 合并请求
    - [x] 持续集成
    - [x] 标记
    - [x] 代码质量
- [x] CI流水线
    - [x] 全局变量配置
    - [x] 可视化流程
    - [x] 集成nexus制品库
    - [x] 集成sonar代码检查
    - [x] 支持Go语言流程
    - [x] 文件缓存
## 测试管理

- [x] 用例库
    - [x] 用例文件夹
    - [x] 测试用例
- [x] 测试计划
    - [x] 计划文件夹
    - [x] 测试执行
- [ ] 自动化测试
    - [ ] API测试
    - [ ] 单元测试
    - [ ] 压力测试
    - [ ] 自动化UI测试
## 持续部署

- [x] 应用部署
- [x] 资源
    - [x] 实例视图
    - [x] 资源视图
- [ ] 流水线-CD
    - [ ] CD流水线与CI流程融合 
    - [ ] CD支持主机镜像部署 
    - [ ] CD支持主机进行制品库部署 
    - [ ] CD支持应用集群部署 
- [x] 环境配置
- [x] 集群管理
    - [x] 节点管理
    - [x] 环境管理
    - [x] 权限管理
    - [ ] 网络管理
    - [ ] 对接融合监控平台
- [ ] 支持制品库制品主机部署
- [ ] Harbor Chart集成
- [ ] 容器镜像安全扫描功能
- [ ] 应用自定义健康检查
## 运营管理

- [x] 图表
    - [x] 敏捷报表
      - [x] 燃尽图
      - [x] 冲刺报告
      - [x] 累积流量图
      - [x] 版本报告
      - [x] 迭代速度图
      - [x] 史诗报告
      - [x] 统计图
      - [x] 史诗燃耗图
      - [x] 版本燃耗图
    - [x] 测试报表
      - [x] 测试摘要
      - [x] 测试追踪性报告
    - [x] DevOps报表
      - [x] 代码提交图
      - [x] 构建时长图
      - [x] 构建次数图
      - [x] 部署时长图
      - [x] 部署次数图
- [x] 事务管理